#
# sgpp(simpleg pre-processor in awk)
#
BEGIN{
	# alias̾
	cmds = "window line circle string point rectangle bezier"
	split(cmds, tmparray)
	for(i in tmparray) alias[tmparray[i]] = substr(tmparray[i], 1, 1)
}

/"/{
	$0 = conv_string($0)
	# " "Ρ\ פ򤢤餫\040פľƤ
}
NF >= 1{
	if($1 in alias) $1 = alias[$1]
}

$1 == "l" && NF >= 7 && NF % 2 == 1{
	for(i = 2; i <= NF-3; i += 2) print "l", $i, $(i+1), $(i+2), $(i+3)
	next
}
$1 == "p" && NF == 3{
	print "l", $2, $3, $2, $3
	next
}
$1 == "r" && NF == 5{
	print "l", $2, $3, $4, $3
	print "l", $4, $3, $4, $5
	print "l", $4, $5, $2, $5
	print "l", $2, $5, $2, $3
	next
}
$1 == "b" && NF >= 7 && NF % 2 == 1{
	for(i = 2; i <= NF; i++) tmparray[1+i%2, int(i/2)] = $i
	bezier((NF-1)/2, tmparray)
	next
}
{
	print
}

function bezier(n, ary,		i, j, k, flg, newary){
	for(i = 2; i < n; i++){
		if(sqdist(ary[1,1], ary[2,1], ary[1,n], ary[2,n],
			  ary[1,i], ary[2,i]) >= 0.25) break
	}
	if(i == n){ # ʬľ˶᤯ʤäľϤƽ
		print "l", round(ary[1,1]), round(ary[2,1]),
			   round(ary[1,n]), round(ary[2,n])
		return
	}

	for(flg = 0; flg <= 1; flg++){
		for(k = 1; k <= 2; k++){
			for(i = 1; i <= n; i++)
				newary[k, i] = ary[k, flg ? n+1-i: i]
			for(j = 2; j <= n; j++)
				for(i = n; i >= j; i--) newary[k, i] = \
					(newary[k, i] + newary[k, i-1]) / 2
		}
		bezier(n, newary)
	}
}

function abs(x){
	return x > 0 ? x : -x
}
function round(x){
	return int(x + .5)
}
function sqdist(x1, y1, x2, y2, x3, y3,		a, b){
# (x1, y1)(x2, y2)ľ(x3, y3)ȤεΥ2
	b = (y2-y1)*(y2-y1) + (x2-x1)*(x2-x1)
	if(!b) return (x3-x1)*(x3-x1) + (y3-y1)*(y3-y1)
	a = (x2-x1)*(y3-y1) - (y2-y1)*(x3-x1)
	return a * a / b
}

# " "Ρ\ פ\040פľ
function conv_string(s,		ret, mid){
	while(match(s, /"([^\\"]|\\.)*"/)){
		ret = ret substr(s, 1, RSTART - 1)
		mid = substr(s, RSTART, RLENGTH)
		s = substr(s, RSTART + RLENGTH)

		while(match(mid, /[^\\]|\\./)){
			ret = ret substr(mid, 1, RSTART - 1) \
			    (substr(mid, RSTART + RLENGTH - 1, 1) == " " ? \
				"\\040" : substr(mid, RSTART, RLENGTH))
			mid = substr(mid, RSTART + RLENGTH)
		}
		ret = ret mid
	}
	return ret s
}
