#include <stdio.h>
#include <ctype.h>
#define LINSIZ	1000

#define isoctal(c) (isdigit(c) && (c) < '8')
#define is_space(c) (isascii(c) && isspace(c))
#define is_octal(c) (isascii(c) && isoctal(c))
#define ctoi(c) ((c) - '0')

main(ac, av)
int	ac;
char	*av[];
{
	char	line[LINSIZ], *s, *p, *strchr();
	int	x1, y1, x2, y2, r;
	double	a1, a2, b;
	int	winmade = 0;

	if(ac > 1 && !strcmp(av[1], "-l")){
		ac--, av++, gsetnoharddraw(1);
	}
	if(ac > 1){
		fprintf(stderr, "Usage: simpleg [-l]\n"), exit(-1);
	}

	while(NULL != (s = fgets(line, LINSIZ, stdin))){
		while(is_space(*s)) s++;
		switch(*s++){
		case 'w':
			if(winmade || !is_space(*s)) goto err;
			if(2 != sscanf(++s, "%d %d", &x1, &y1)) goto err;
			ginit(x1, y1);
			winmade = 1;
			break;
		case 'l':
			if(!winmade || !is_space(*s)) goto err;
			if(4 != sscanf(++s, "%d %d %d %d",
				&x1, &y1, &x2, &y2)) goto err;
			gline(x1, y1, x2, y2);
			break;
		case 'c':
			if(!winmade || !is_space(*s)) goto err;
			if(6 != sscanf(++s, "%d %d %d %lf %lf %lf",
				&x1, &y1, &r, &a1, &a2, &b)) goto err;
			gcircle(x1, y1, r, a1, a2, b);
			break;
		case 's':
			if(!winmade || !is_space(*s)) goto err;
			if(2 != sscanf(++s, "%d %d", &x1, &y1)) goto err;
			if(NULL == (s = strchr(s, '"'))) goto err;
			for(p = ++s; *p != '"'; p++){
				if(*p == '\0' || *p == '\n') goto err;
				if(*p == '\\'){char *q, *r;
					if(isoctal(p[1]) && isoctal(p[2]) &&
					   isoctal(p[3])){
						*p = (ctoi(p[1]) << 6) +
						     (ctoi(p[2]) << 3) +
						      ctoi(p[3]);
						q = p + 1, r = p + 4;
					} else {
						q = p, r = p + 1;
					}
					while(*q++ = *r++);
				}
			}
			*p = '\0';
			gstring(x1, y1, s);
			break;
		case 'e':
		case '#':
		case '\n':
		case '\0':
			break; /* do nothing */
		default:
			goto err;
		}
	}
	gend(), exit(0);

err:
	fprintf(stderr, "Data error: %s", line), gend(), exit(1);
}
