#include <stdio.h>
#include <ctype.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
char	*getenv(), *strchr();

static	void    ujistoXChar2b();

static	Display *mydisp;
static	Window mywin;
static	GC mygc;
static	int myscrn;
static	XSizeHints myhints;
static	XWMHints mywmhints;
static	XEvent myev;
static	unsigned long mybg, myfg;
static	XSetWindowAttributes myattr;
static	char mykeybuf;
static	int winexist = 0;
static	int no_hardware_drawlines = 0;

#define PI 3.1415926535897932
#define KANJI(s) (((s)[0] & 0x80) && ((s)[1] & 0x80))
#define EOS(s)	(*(s) == '\0')
#define is_alnum(c) (isascii(c) && isalnum(c))
#define is_digit(c) (isascii(c) && isdigit(c))

static	Font	findkfont()
{
	static	int	find = 0;
	static	Font	font;
	XFontStruct	*tmpfontstr;

	if(!find){
		 /* ե̾ȤƤꤽ̾ŬˤĤ */
		if(NULL == (tmpfontstr = XLoadQueryFont(mydisp, "kanji24")) &&
		   NULL == (tmpfontstr = XLoadQueryFont(mydisp, "gmwk-24")) &&
		   NULL == (tmpfontstr = XLoadQueryFont(mydisp, "j_knj24c"))&&
		   NULL == (tmpfontstr = XLoadQueryFont(mydisp, "k24"))){
			fprintf(stderr, "Kanji font not found.\n");
			exit(1);
		}
		font = tmpfontstr -> fid;
		find++;
	}
	return font;
}

static	Font	findafont()
{
	static	int	find = 0;
	static	Font	font;
	XFontStruct	*tmpfontstr;

	if(!find){
		 /* ANKե̾ȤƤꤽ̾ŬˤĤ */
		if(NULL == (tmpfontstr = XLoadQueryFont(mydisp, "12x24")) &&
		   NULL == (tmpfontstr = XLoadQueryFont(mydisp, "gmw-24")) &&
		   NULL == (tmpfontstr = XLoadQueryFont(mydisp, "j_ank24c"))&&
		   NULL == (tmpfontstr = XLoadQueryFont(mydisp, "r24"))){
			fprintf(stderr, "ASCII font not found.\n");
			exit(1);
		}
		font = tmpfontstr -> fid;
		find++;
	}
	return font;
}

static	void	ujistoXChar2b(xs, s)
 /* EUC 1ʸXlib2ХʸѴ */
XChar2b *xs;
char  *s;
{
	xs -> byte1 = (unsigned char)s[0] & 0x7F;
	xs -> byte2 = (unsigned char)s[1] & 0x7F;
}

static	void	winNEchk()
{
	if(winexist){
		fprintf(stderr, "Window already created\n");
		exit(1);
	}
}

static	void	winEXchk()
{
	if(!winexist){
		fprintf(stderr, "Window not created\n");
		exit(1);
	}
}

gsetnoharddraw(flg)
int	flg; /* boolean */
{
	winNEchk();
	no_hardware_drawlines = flg;
}

ginit(x, y)
int	x, y;
{
    static char *dummyarg[] = {"dummy", NULL};

    winNEchk();

     /* ɥΥ֤λ */
    myhints.width = x; myhints.height = y;
    myhints.x = 20; myhints.y = 20; myhints.flags = PPosition|PSize;
    
    mydisp = XOpenDisplay(NULL); myscrn = DefaultScreen(mydisp);
    mybg = WhitePixel(mydisp, myscrn); myfg = BlackPixel(mydisp, myscrn);
    mywin = XCreateSimpleWindow(mydisp, DefaultRootWindow(mydisp), 
        myhints.x, myhints.y, myhints.width, myhints.height, 5, myfg, mybg);
    XSetStandardProperties(mydisp, mywin, "Graphic", "Graphic", None,
        dummyarg, 1, &myhints);
    mygc = XCreateGC(mydisp, mywin, 0, 0);
    XSetBackground(mydisp, mygc, mybg); XSetForeground(mydisp, mygc, myfg);
    if(no_hardware_drawlines)
	XSetLineAttributes(mydisp, mygc, 1, LineSolid, CapButt, JoinMiter);
    mywmhints.flags = InputHint; mywmhints.input = True;
    XSetWMHints(mydisp, mywin, &mywmhints);
    XSelectInput(mydisp, mywin, KeyPressMask|ExposureMask);
    XMapRaised(mydisp, mywin);
     /* MapSelectInputǤʤ㤤ʤä */
    myattr.backing_store = WhenMapped;
    XChangeWindowAttributes(mydisp, mywin, CWBackingStore, &myattr);
     /* Хå󥰥ȥϥФˤäƤϤǤʤ⤢Τ */
    while(XNextEvent(mydisp, &myev),
	  myev.type != Expose || myev.xexpose.count != 0);
     /* Expose ٥Ȥ褿ºݤԤ */

    winexist = 1;
}

gend()
{
    winEXchk();
    for(;;){
	XNextEvent(mydisp, &myev); if(myev.type != KeyPress) continue;
	if(1 > XLookupString((XKeyEvent *)&myev, &mykeybuf, 1, NULL, NULL))
	    continue;
	if(mykeybuf == ('D' & 0x1F) || mykeybuf == ('C' & 0x1F)) break;
    }
    XCloseDisplay(mydisp);
    winexist = 0;
}

gline(x1, y1, x2, y2)
int	x1, y1, x2, y2;
{
	winEXchk();
	if(no_hardware_drawlines){
		XDrawPoint(mydisp, mywin, mygc, x1, y1);
		if(!(x1 == x2 && x2 == y2)){
			XDrawPoint(mydisp, mywin, mygc, x2, y2);
			XDrawLine(mydisp, mywin, mygc, x1, y1, x2, y2);
		}
	} else {
		if(!(x1 == x2 && x2 == y2))
			XDrawLine(mydisp, mywin, mygc, x1, y1, x2, y2);
		else
			XDrawPoint(mydisp, mywin, mygc, x1, y1);
	}
}

gcircle(x, y, r, s1, s2, b)
int	x, y, r;
double	s1, s2, b;
{
	int	xo, yo, ang1, ang2;
	unsigned int	wid, hei;

	winEXchk(); 
	if(b >= 1.0){
		xo = x - (int)((double)r / b);
		yo = y - r;
	} else {
		xo = x - r;
		yo = y - (int)((double)r * b);
	}
	wid = (x - xo) * 2;
	hei = (y - yo) * 2;
	ang1 = (int)((s1 / PI) * 180.0 * 64.0);
	ang2 = (int)((s2 / PI) * 180.0 * 64.0) - ang1;
	if(ang1 == 0 && ang2 == 0) ang2 += 64 * 360;
	else {
		if(ang1 < 0) ang1 += 64 * 360 * ((-ang1 - 1) / 64 / 360 + 1);
		 else	     ang1 -= 64 * 360 * ((ang1 - 1) / 64 / 360);
		if(ang2 < 0) ang2 += 64 * 360 * ((-ang2 - 1) / 64 / 360 + 1);
		 else	     ang2 -= 64 * 360 * ((ang2 - 1) / 64 / 360);
	}
	XDrawArc(mydisp, mywin, mygc, xo, yo, wid, hei, ang1, ang2);
}

gstring(x, y, s) /* 1ХȲ̾б */
int	x, y;
char	*s;
{
	XChar2b	xc;

	winEXchk(); 
	while(!EOS(s)){
		if(KANJI(s)){
			XSetFont(mydisp, mygc, findkfont());
			ujistoXChar2b(&xc, s);
			XDrawString16(mydisp, mywin, mygc, x, y, &xc, 1);
      			s += 2;
			x += 24;
		} else {
			XSetFont(mydisp, mygc, findafont());
			XDrawString(mydisp, mywin, mygc, x, y, s, 1);
			s++;
			x += 12;
		} /* ʸ24ɥåȤȤ12ɥåȤȤꤷƤ
		     ʤXΥ饤֥ؿƤʸĴ٤٤ */
	}
}
